unit VaxCallParking;

interface
 uses

     System.Classes,
     SysUtils,
    VaxCallSessionRoute,
    VaxDefine,
    VaxTeleServerSIP,
    VaxServerExCOM;


type TVaxCallParking = class

    public
        m_objVaxServer: TVaxTeleServerSIP;

    public
       constructor Create(); reintroduce; overload;

       function OnIncomingCall(nSessionId: Integer; sDialNo: String; nFromPeerType: Integer) : Boolean;
       function OnCallSessionTransferBlind(nTransfererSessionId: Integer; nTransfererChannelId: Integer; sTransferer: String; sTransferee: String; sTransferTo: String) : Boolean;

       procedure StartMusicCallPark(nSessionId: Integer; nChannelId: Integer);
       procedure StopMusicCallPark(nSessionId: Integer);
end;

implementation

      constructor TVaxCallParking.Create();
        begin

        end;

        function TVaxCallParking.OnIncomingCall(nSessionId: Integer; sDialNo: String; nFromPeerType: Integer) : Boolean;
        var
          sPrefixedDialNo: string;
          nSlotId: Integer;
        begin

    	    sPrefixedDialNo := sDialNo;
          Trim(sPrefixedDialNo);

          if(AnsiPos('#3#', sPrefixedDialNo) <> 1) Then
            Exit(False);

          sPrefixedDialNo := StringReplace(sPrefixedDialNo, '#3#', '', [rfReplaceAll, rfIgnoreCase]);
          Trim(sPrefixedDialNo);

          nSlotId := StrToInt(sPrefixedDialNo);

          TVaxServerExCOM.mVaxExCOM.ConnectToParkedCallSession(nSessionId, 0, nSlotId);
          StopMusicCallPark(nSessionId);

          Result := True;

        end;

        function TVaxCallParking.OnCallSessionTransferBlind(nTransfererSessionId: Integer; nTransfererChannelId: Integer; sTransferer: String; sTransferee: String; sTransferTo: String) : Boolean;
        var
          nChannelId: Integer;
          nSlotId: Integer;
          sPrefixedSlotId: string;
        begin

          nChannelId := 0;

          if(nTransfererChannelId = 0) Then
            nChannelId := 1;

  	      sPrefixedSlotId := sTransferTo;
          Trim(sPrefixedSlotId);

          if(AnsiPos('#2#', sPrefixedSlotId) <> 1) Then
            Exit(False);

          sPrefixedSlotId := StringReplace(sPrefixedSlotId, '#2#', '', [rfReplaceAll, rfIgnoreCase]);
          Trim(sPrefixedSlotId);

          nSlotId := StrToInt(sPrefixedSlotId);

          TVaxServerExCOM.mVaxExCOM.AcceptTransferBlind(nTransfererSessionId, sTransferee, sTransferee, '', -1, '', 30);
          TVaxServerExCOM.mVaxExCOM.ParkCallSession(nTransfererSessionId, nChannelId, nSlotId);

          StartMusicCallPark(nTransfererSessionId, nChannelId);

          Result := True;

        end;

        procedure TVaxCallParking.StartMusicCallPark(nSessionId: Integer; nChannelId: Integer);
        var
          nMusicId: Integer;
        begin

          nMusicId := TVaxServerExCOM.mVaxExCOM.GetCallParkMusicId();

          if(nMusicId = -1) then
            Exit();

          TVaxServerExCOM.mVaxExCOM.PlayWaveStartToCallSession(nSessionId, nChannelId, nMusicId, True, 0);

        end;

        procedure TVaxCallParking.StopMusicCallPark(nSessionId: Integer);
        var
          nMusicId: Integer;
        begin

          nMusicId := TVaxServerExCOM.mVaxExCOM.GetCallParkMusicId();

          TVaxServerExCOM.mVaxExCOM.PlayWaveStopToCallSession(nSessionId, 0, nMusicId);
	        TVaxServerExCOM.mVaxExCOM.PlayWaveStopToCallSession(nSessionId, 1, nMusicId);

        end;
end.

