﻿Public Class cStoreLine
    Inherits cStoreRegistry

    Private Const LINE_ROOT_PATH = "Lines\\"

    Public Sub New()

    End Sub

    '////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////

    Public Function AddLine(ByVal sLineName As String, ByVal sDisplayName As String, ByVal sUserName As String, ByVal sAuthUser As String, ByVal sAuthPwd As String, ByVal sDomainRealm As String, ByVal sProxySIP As String, ByVal sOutboundProxySIP As String, ByVal sCodecList As String, ByVal bRegister As Boolean) As Boolean

        If (sLineName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = LINE_ROOT_PATH + sLineName

        MyBase.SetTEXT(sPath, "DisplayName", sDisplayName)
        MyBase.SetTEXT(sPath, "UserName", sUserName)
        MyBase.SetTEXT(sPath, "AuthUser", sAuthUser)

        MyBase.SetTEXT(sPath, "AuthPwd", sAuthPwd)
        MyBase.SetTEXT(sPath, "DomainRealm", sDomainRealm)
        MyBase.SetTEXT(sPath, "ProxySIP", sProxySIP)

        MyBase.SetTEXT(sPath, "OutboundProxySIP", sOutboundProxySIP)
        MyBase.SetTEXT(sPath, "CodecList", sCodecList)

        MyBase.SetBOOL(sPath, "Register", bRegister)
        Return True

    End Function

    Public Sub RemoveLine(ByVal sLineName As String)

        If (sLineName.Length = 0) Then
            Return
        End If

        Dim sPath As String = LINE_ROOT_PATH + sLineName
        MyBase.DeleteSubKey(sPath)

    End Sub

    '//////////////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////////////

    Public Function GetLine(ByVal sLineName As String, ByRef sDisplayName As String, ByRef sUserName As String, ByRef sAuthUser As String, ByRef sAuthPwd As String, ByRef sDomainRealm As String, ByRef sProxySIP As String, ByRef sOutboundProxySIP As String, ByRef sCodecList As String, ByRef bRegister As Boolean) As Boolean

        If (sLineName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = LINE_ROOT_PATH + sLineName

        MyBase.GetTEXT(sPath, "DisplayName", sDisplayName)
        MyBase.GetTEXT(sPath, "UserName", sUserName)
        MyBase.GetTEXT(sPath, "AuthUser", sAuthUser)

        MyBase.GetTEXT(sPath, "AuthPwd", sAuthPwd)
        MyBase.GetTEXT(sPath, "DomainRealm", sDomainRealm)
        MyBase.GetTEXT(sPath, "ProxySIP", sProxySIP)

        MyBase.GetTEXT(sPath, "OutboundProxySIP", sOutboundProxySIP)
        MyBase.GetTEXT(sPath, "CodecList", sCodecList)
        MyBase.GetBOOL(sPath, "Register", bRegister)

        Return True
    End Function

    Public Function GetLineNameAll(ByRef objLineList As List(Of String)) As Boolean

        objLineList.Clear()

        Dim sPath As String = LINE_ROOT_PATH

        Return MyBase.EnumSubKeys(sPath, objLineList)
    End Function

    '//////////////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////////////

    Public Function AddLineRoute(ByVal sLineName As String, ByVal nToPeerType As Integer, ByVal sToPeerName As String, ByVal bRejected As Boolean, ByVal sRoomName As String, ByVal sQueueName As String, ByVal sRingGroupName As String) As Boolean

        If (sLineName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = LINE_ROOT_PATH + sLineName

        MyBase.SetINT(sPath, "ToPeerType", nToPeerType)

        MyBase.SetTEXT(sPath, "ToPeerName", sToPeerName)
        MyBase.SetTEXT(sPath, "RoomName", sRoomName)

        MyBase.SetBOOL(sPath, "Rejected", bRejected)

        MyBase.SetTEXT(sPath, "QueueName", sQueueName)
        MyBase.SetTEXT(sPath, "RingGroupName", sRingGroupName)
        Return True
    End Function

    Public Function GetLineRoute(ByVal sLineName As String, ByRef nToPeerType As Integer, ByRef sToPeerName As String, ByRef bRejected As Boolean, ByRef sRoomName As String, ByRef sQueueName As String, ByRef sRingGroupName As String) As Boolean

        If (sLineName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = LINE_ROOT_PATH + sLineName

        MyBase.GetTEXT(sPath, "ToPeerName", sToPeerName)
        MyBase.GetTEXT(sPath, "RoomName", sRoomName)

        MyBase.GetINT(sPath, "ToPeerType", nToPeerType)
        MyBase.GetBOOL(sPath, "Rejected", bRejected)

        MyBase.GetTEXT(sPath, "QueueName", sQueueName)
        MyBase.GetTEXT(sPath, "RingGroupName", sRingGroupName)

        Return True
    End Function

    Public Function RemoveLineRoute(ByVal sLineName As String) As Boolean

        If (sLineName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = LINE_ROOT_PATH + sLineName

        MyBase.DeleteValue(sPath, "ToPeerName")
        MyBase.DeleteValue(sPath, "RoomName")

        MyBase.DeleteValue(sPath, "ToPeerType")
        MyBase.DeleteValue(sPath, "Rejected")

        MyBase.DeleteValue(sPath, "QueueName")
        MyBase.DeleteValue(sPath, "RingGroupName")

        Return True
    End Function

    Public Function IsDataStored() As Boolean
        Return MyBase.IsKeyExist(LINE_ROOT_PATH)
    End Function

End Class
