﻿Public Class cStoreRingGroup
    Inherits cStoreRegistry

    Private Const RING_GROUP_ROOT_PATH = "RingGroups\\"

    Public Sub New()

    End Sub

    '///////////////////////////////////////////////////////////////////////////////////
    '///////////////////////////////////////////////////////////////////////////////////

    Public Function AddRingGroup(ByVal sRingGroupName As String) As Boolean

        If (sRingGroupName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = RING_GROUP_ROOT_PATH + sRingGroupName
        MyBase.SetTEXT(sPath, "RingGroupName", sRingGroupName)

        Return True

    End Function

    Public Function RemoveRingGroup(ByVal sRingGroupName As String) As Boolean

        If (sRingGroupName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = RING_GROUP_ROOT_PATH + sRingGroupName
        MyBase.DeleteSubKey(sPath)

        Return True

    End Function

    Public Function GetRingGroupList(ByRef objListRingGroup As List(Of String)) As Boolean

        objListRingGroup.Clear()

        Dim sPath As String = RING_GROUP_ROOT_PATH
        Return MyBase.EnumSubKeys(sPath, objListRingGroup)

    End Function

    '//////////////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////////////

    Public Function SetRingGroupProcessMode(ByVal sRingGroupName As String, ByVal nProcessMode As Integer, ByVal nProcessType As Integer) As Boolean

        If (sRingGroupName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = RING_GROUP_ROOT_PATH + sRingGroupName
        MyBase.SetINT(sPath, "ProcessMode", nProcessMode)
        MyBase.SetINT(sPath, "ProcessType", nProcessType)
        Return True

    End Function

    Public Function GetRingGroupProcessMode(ByVal sRingGroupName As String, ByRef nProcessMode As Integer, ByRef nProcessType As Integer) As Boolean

        If (sRingGroupName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = RING_GROUP_ROOT_PATH + sRingGroupName
        MyBase.GetINT(sPath, "ProcessMode", nProcessMode)
        MyBase.GetINT(sPath, "ProcessType", nProcessType)
        Return True

    End Function

    '//////////////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////////////

    Public Function AddRingGroupAgent(ByVal sRingGroupName As String, ByVal sUserName As String) As Boolean

        If (sRingGroupName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = RING_GROUP_ROOT_PATH + sRingGroupName + "\\" + sUserName

        Return MyBase.SetTEXT(sPath, "UserName", sUserName)

    End Function

    Public Function RemoveRingGroupAgent(ByVal sRingGroupName As String, ByVal sUserName As String) As Boolean

        If (sRingGroupName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = RING_GROUP_ROOT_PATH + sRingGroupName + "\\" + sUserName
        Return MyBase.DeleteSubKey(sPath)

    End Function

    Public Function GetRingGroupAgentList(ByVal sRingGroupName As String, ByRef objRingGroupAgentList As List(Of String)) As Boolean

        objRingGroupAgentList.Clear()

        Dim sPath As String = RING_GROUP_ROOT_PATH + sRingGroupName
        Return MyBase.EnumSubKeys(sPath, objRingGroupAgentList)

    End Function

    '//////////////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////////////////

    Public Function SetRingGroupAgentPriority(ByVal sRingGroupName As String, ByVal sUserName As String, ByVal nPriority As Integer) As Boolean

        If (sRingGroupName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = RING_GROUP_ROOT_PATH + sRingGroupName + "\\" + sUserName
        MyBase.SetINT(sPath, "Priority", nPriority)
        Return True

    End Function

    Public Function GetRingGroupAgentPriority(ByVal sRingGroupName As String, ByVal sUserName As String, ByRef nPriority As Integer) As Boolean

        If (sRingGroupName.Length = 0) Then
            Return False
        End If

        Dim sPath As String = RING_GROUP_ROOT_PATH + sRingGroupName + "\\" + sUserName

        MyBase.GetINT(sPath, "Priority", nPriority)
        Return True

    End Function

    Public Function IsDataStored() As Boolean
        Return MyBase.IsKeyExist(RING_GROUP_ROOT_PATH)
    End Function

End Class
