#pragma once

//------------------------------------------------------------------------------------------
//-------------			CRingGroupDetails
//------------------------------------------------------------------------------------------
class CRingGroupAlgoAgentList;
class CRingGroupUserList;

class CRingGroupDetails
{

public:

	CRingGroupDetails();
	~CRingGroupDetails();	

public:

	CString m_sRingGroupName;

	int m_nProcessMode;
	int m_nProcessType;

public:

	CRingGroupUserList* m_pRingGroupUserList;

	BOOL AddRingGroupAgent(LPCTSTR sAgentName);
	void RemoveRingGroupAgent(LPCTSTR sAgentName);
	
	BOOL GetRingGroupAgentList(CStringList& sListAgentName);

	int GetRingGroupAgentCount();
	CString GetRingGroupAgentAt(int nIndex);

	
};

typedef CMap<CString, LPCTSTR, CRingGroupDetails*, CRingGroupDetails*> CRingGroupListMap;

//------------------------------------------------------------------------------------------
//-------------			CRingGroupList
//------------------------------------------------------------------------------------------

class CRingGroupList
{

public:

	CRingGroupList(void);
	~CRingGroupList(void);

private:

	CRingGroupListMap* m_pRingGroupList;

private:

	
	CString GenKey(LPCTSTR sRingGroupName);
	CRingGroupDetails* FindRingGroup(LPCTSTR sRingGroupName);

public:

	BOOL AddRingGroup(LPCTSTR sRingGroupName);
	void RemoveRingGroup(LPCTSTR sRingGroupName);

	void SetRingGroupProcessMode(LPCTSTR sQueueName, int nProcessMode, int nProcessType);
	BOOL GetRingGroupDetails(LPCTSTR sRingGroupName, int& nProcessMode, int& nProcessType, CStringList& sListAgentName);

	BOOL AddRingGroupAgent(LPCTSTR sRingGroupName, LPCTSTR sAgentName);
	void RemoveRingGroupAgent(LPCTSTR sRingGroupName, LPCTSTR sAgentName);

	BOOL GetRingGroupList(CStringList& sListRingGroupName);

	int GetRingGroupAgentCount(LPCTSTR sRingGroupName);
	CString GetRingGroupAgentAt(LPCTSTR sRingGroupName,int nIndex);

	void DeleteRingGroupAll();

};






