#include "StdAfx.h"
#include "StoreCOMM.h"

#define ROOT_PATH	"COMM\\"

CStoreCOMM::CStoreCOMM(void)
{
	
}

CStoreCOMM::~CStoreCOMM(void)
{
	
}

BOOL CStoreCOMM::Initialize(LPCTSTR sDomainRealm, LPCTSTR sSIPListenIP, int nSIPListenPort, LPCTSTR sRTPListenIP, int nRTPListenPort)
{
	CString sKeyPath;
	sKeyPath.Format("%s", ROOT_PATH);

	CStoreRegistry::SetTEXT(sKeyPath, "DomainRealm", sDomainRealm);
	CStoreRegistry::SetTEXT(sKeyPath, "SIPListenIP", sSIPListenIP);
	CStoreRegistry::SetTEXT(sKeyPath, "RTPListenIP", sRTPListenIP);

	CStoreRegistry::SetINT(sKeyPath, "SIPListenPort", nSIPListenPort);
    CStoreRegistry::SetINT(sKeyPath, "RTPListenPort", nRTPListenPort);

	return TRUE;	
}

BOOL CStoreCOMM::GetInitialize(LPCTSTR sDomainRealm, CString&  sSIPListenIP, int& nSIPListenPort, CString& sRTPListenIP, int& nRTPListenPort)
{
	CString sKeyPath;
	sKeyPath.Format("%s", ROOT_PATH);

	CStoreRegistry::GetTEXT(sKeyPath, "DomainRealm",(CString)sDomainRealm);
    CStoreRegistry::GetTEXT(sKeyPath, "SIPListenIP", sSIPListenIP);
    CStoreRegistry::GetTEXT(sKeyPath, "RTPListenIP", sRTPListenIP);

	CStoreRegistry::GetINT(sKeyPath, "SIPListenPort", nSIPListenPort);
	CStoreRegistry::GetINT(sKeyPath, "RTPListenPort", nRTPListenPort);

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

BOOL CStoreCOMM::SetMusicHold(CString sFileName)
{
	CString sKeyPath;
	sKeyPath= ROOT_PATH;

	return CStoreRegistry::SetTEXT(sKeyPath, "MusicHold", sFileName);
}

BOOL CStoreCOMM::GetMusicHold(CString& sFileName)
{
	CString sKeyPath;
	sKeyPath= ROOT_PATH;

	return CStoreRegistry::GetTEXT(sKeyPath, "MusicHold", sFileName);
}

//////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

BOOL CStoreCOMM::SetMusicDialTone(CString sFileName)
{
	CString sKeyPath;
	sKeyPath= ROOT_PATH;

	return CStoreRegistry::SetTEXT(sKeyPath, "MusicDialTone", sFileName);
}

BOOL CStoreCOMM::GetMusicDialTone(CString& sFileName)
{
	CString sKeyPath;
	sKeyPath= ROOT_PATH;

	return CStoreRegistry::GetTEXT(sKeyPath, "MusicDialTone", sFileName);
}

BOOL CStoreCOMM::SetMusicCallPark(LPCTSTR sFileName)
{
	CString sKeyPath;
	sKeyPath= ROOT_PATH;

	return CStoreRegistry::SetTEXT(sKeyPath, "MusicCallParking", sFileName);
}

BOOL CStoreCOMM::GetMusicCallPark(CString& sFileName)
{
	CString sKeyPath;
	sKeyPath= ROOT_PATH;

	return CStoreRegistry::GetTEXT(sKeyPath, "MusicCallParking", sFileName);
}

BOOL CStoreCOMM::IsDataStored()
{
	return CStoreRegistry::IsKeyExist(ROOT_PATH);
}