#include "StdAfx.h"
#include "VaxServerCOM.h"
#include <afxctl.h>


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#ifdef __cplusplus
extern "C"{
#endif 

#ifndef __IID_DEFINED__
#define __IID_DEFINED__

typedef struct _IID
{
    unsigned long x;
    unsigned short s1;
    unsigned short s2;
    unsigned char  c[8];
} IID;

#endif // __IID_DEFINED__

#ifndef CLSID_DEFINED
#define CLSID_DEFINED
typedef IID CLSID;
#endif // CLSID_DEFINED

const IID LIBID_VAXTELESERVERCOMLib = {0xD5E6B425,0x4D00,0x41D2,{0xBD,0xAD,0xB8,0x6D,0x48,0x29,0x85,0x34}};
const IID DIID__IVaxServerSIPEvents = {0xC30149C5,0x6CEC,0x4748,{0x99,0x2B,0x04,0x4E,0x94,0xB2,0xFA,0xC1}};
const IID IID_IVaxServerSIP         = {0x0588AD74,0x8592,0x4902,{0x8F,0x59,0xC1,0xE2,0xD1,0x7B,0x5B,0xCA}};
const CLSID CLSID_VaxServerSIP      = {0x07B8565E,0xC5BD,0x4420,{0x9F,0xD0,0x47,0xB2,0x64,0x44,0xC8,0xED}};

#ifdef __cplusplus
}
#endif

IMPLEMENT_DYNCREATE(CVaxServerCOM, CCmdTarget)

CVaxServerCOM::CVaxServerCOM()
{
	m_bShowMsgBoxCOM = TRUE;

	EnableAutomation();
	
	m_pVaxSIP = NULL;
	m_pVaxEvents = NULL;

	LoadObjectCOM();
}

CVaxServerCOM::~CVaxServerCOM()
{
	UnLoadObjectCOM();
}


void CVaxServerCOM::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}


BEGIN_MESSAGE_MAP(CVaxServerCOM, CCmdTarget)
	//{{AFX_MSG_MAP(CVaxServerCOM)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



BEGIN_DISPATCH_MAP(CVaxServerCOM, CCmdTarget)
	
	DISP_FUNCTION(CVaxServerCOM, "OnRegisterUser", OnRegisterUser, VT_EMPTY, VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnRegisterUserSuccess", OnRegisterUserSuccess, VT_EMPTY, VTS_BSTR VTS_BSTR VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnRegisterUserFailed", OnRegisterUserFailed, VT_EMPTY, VTS_BSTR VTS_BSTR VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnUnRegisterUser", OnUnRegisterUser, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnIncomingCall", OnIncomingCall, VT_EMPTY, VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4) 
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionFailed", OnCallSessionFailed, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionConnected", OnCallSessionConnected, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionClosed", OnCallSessionClosed, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4) 
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionOnHold", OnCallSessionOnHold, VT_EMPTY, VTS_I4 VTS_I4) 
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionOffHold", OnCallSessionOffHold, VT_EMPTY, VTS_I4 VTS_I4) 
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionTransferBlind", OnCallSessionTransferBlind, VT_EMPTY, VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionTransferConsult", OnCallSessionTransferConsult, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR) 
	DISP_FUNCTION(CVaxServerCOM, "OnLineRegisterTrying", OnLineRegisterTrying, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnLineRegisterFailed", OnLineRegisterFailed, VT_EMPTY, VTS_BSTR VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnLineRegisterSuccess", OnLineRegisterSuccess, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnLineUnRegisterTrying", OnLineUnRegisterTrying, VT_EMPTY, VTS_BSTR )
	DISP_FUNCTION(CVaxServerCOM, "OnLineUnRegisterFailed", OnLineUnRegisterFailed, VT_EMPTY, VTS_BSTR VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnLineUnRegisterSuccess", OnLineUnRegisterSuccess, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnChatMessageText", OnChatMessageText, VT_EMPTY, VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4 VTS_BSTR VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnChatMessageTyping", OnChatMessageTyping, VT_EMPTY, VTS_I4 VTS_BSTR VTS_BSTR VTS_BOOL VTS_I4 VTS_BSTR VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnChatStatusSubscribe", OnChatStatusSubscribe, VT_EMPTY, VTS_I4 VTS_BSTR VTS_BSTR VTS_I4 VTS_BSTR VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnChatMessageSuccess", OnChatMessageSuccess, VT_EMPTY, VTS_I4) 
	DISP_FUNCTION(CVaxServerCOM, "OnChatMessageFailed", OnChatMessageFailed, VT_EMPTY, VTS_I4 VTS_I4 VTS_BSTR) 
	DISP_FUNCTION(CVaxServerCOM, "OnChatMessageTimeout", OnChatMessageTimeout, VT_EMPTY, VTS_I4) 
	DISP_FUNCTION(CVaxServerCOM, "OnOutgoingDiagnosticLog", OnOutgoingDiagnosticLog, VT_EMPTY, VTS_BSTR VTS_BSTR VTS_I4) 
	DISP_FUNCTION(CVaxServerCOM, "OnIncomingDiagnosticLog", OnIncomingDiagnosticLog, VT_EMPTY, VTS_BSTR VTS_BSTR VTS_I4) 
	DISP_FUNCTION(CVaxServerCOM, "OnDetectedDigitDTMF", OnDetectedDigitDTMF, VT_EMPTY, VTS_I4 VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnVaxTeleTick", OnVaxTeleTick, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnSendTimeoutVM", OnSendTimeoutVM, VT_EMPTY, VTS_I4) 
	DISP_FUNCTION(CVaxServerCOM, "OnSendSuccessVM", OnSendSuccessVM, VT_EMPTY, VTS_I4) 
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionDialToneStart", OnCallSessionDialToneStart, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4) 
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionDialToneStop", OnCallSessionDialToneStop, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4) 
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionPlayWaveDone", OnCallSessionPlayWaveDone, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnConferenceRoomPlayWaveDone", OnConferenceRoomPlayWaveDone, VT_EMPTY, VTS_BSTR VTS_I4) 
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionConnecting", OnCallSessionConnecting, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionLost", OnCallSessionLost, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionHangup", OnCallSessionHangup, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionTimeout", OnCallSessionTimeout, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionCancelled", OnCallSessionCancelled, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionTransfering", OnCallSessionTransfering, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionTransferFailed", OnCallSessionTransferFailed, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionTransferTimeout", OnCallSessionTransferTimeout, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionTransfered", OnCallSessionTransfered, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionCreated", OnCallSessionCreated, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionDetectedAMD", OnCallSessionDetectedAMD, VT_EMPTY, VTS_I4 VTS_I4 VTS_BOOL)
	DISP_FUNCTION(CVaxServerCOM, "OnBusyLampSubscribe", OnBusyLampSubscribe, VT_EMPTY, VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnBusyLampUnSubscribe", OnBusyLampUnSubscribe, VT_EMPTY, VTS_I4 VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnBusyLampSubscribeSuccess", OnBusyLampSubscribeSuccess, VT_EMPTY, VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnBusyLampSubscribeFailed", OnBusyLampSubscribeFailed, VT_EMPTY, VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnCallSessionRecordedPCM", OnCallSessionRecordedPCM, VT_EMPTY, VTS_I4 VTS_I4 VTS_I8 VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnConferenceRoomRecordedPCM", OnConferenceRoomRecordedPCM, VT_EMPTY, VTS_BSTR VTS_I8 VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnVaxErrorLog", OnVaxErrorLog, VT_EMPTY, VTS_BSTR VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnAddCallSessionToQueueSuccess", OnAddCallSessionToQueueSuccess, VT_EMPTY, VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnAddCallSessionToQueueFailed", OnAddCallSessionToQueueFailed, VT_EMPTY, VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnVaxLicenseChannel", OnVaxLicenseChannel, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnAddCallSessionToRingGroupSuccess", OnAddCallSessionToRingGroupSuccess, VT_EMPTY, VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnAddCallSessionToRingGroupFailed", OnAddCallSessionToRingGroupFailed, VT_EMPTY, VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnSendReqTransferCallTimeout", OnSendReqTransferCallTimeout, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnSendReqTransferCallAccepted", OnSendReqTransferCallAccepted, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnSendReqTransferCallFailed", OnSendReqTransferCallFailed, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnQualityReportPUBLISH", OnQualityReportPUBLISH, VT_EMPTY, VTS_BSTR VTS_BSTR VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnBusyLampSendStatus", OnBusyLampSendStatus, VT_EMPTY, VTS_BSTR VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnServerConnectingREC", OnServerConnectingREC, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnServerConnectedREC", OnServerConnectedREC, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnServerFailedREC", OnServerFailedREC, VT_EMPTY, VTS_I4 VTS_I4 VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnServerTimeoutREC", OnServerTimeoutREC, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnServerHungupREC", OnServerHungupREC, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnQueuePlayWaveStart", OnQueuePlayWaveStart, VT_EMPTY, VTS_I4 VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnQueuePlayWaveStop", OnQueuePlayWaveStop, VT_EMPTY, VTS_I4 VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnQueueAgentConnectStarted", OnQueueAgentConnectStarted, VT_EMPTY, VTS_BSTR VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnQueueAgentConnectTrying", OnQueueAgentConnectTrying, VT_EMPTY, VTS_BSTR VTS_BSTR VTS_I4 VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnQueueAgentConnectFailed", OnQueueAgentConnectFailed, VT_EMPTY, VTS_BSTR VTS_BSTR VTS_I4 VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnQueueAgentConnectTimeout", OnQueueAgentConnectTimeout, VT_EMPTY, VTS_BSTR VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnQueueAgentConnectSuccess", OnQueueAgentConnectSuccess, VT_EMPTY, VTS_BSTR VTS_BSTR VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnChatStatusSendSubscribeSuccess", OnChatStatusSendSubscribeSuccess, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnChatStatusSendSubscribeFailed", OnChatStatusSendSubscribeFailed, VT_EMPTY, VTS_I4 VTS_I4 VTS_BSTR)
	DISP_FUNCTION(CVaxServerCOM, "OnSendNotifyMsgSuccess", OnSendNotifyMsgSuccess, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CVaxServerCOM, "OnSendNotifyMsgFailed", OnSendNotifyMsgFailed, VT_EMPTY, VTS_I4 VTS_I4 VTS_BSTR)
		
END_DISPATCH_MAP()

// Note: we add support for IID_IVaxServerSIP to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {3DB0F857-BB81-4371-A80C-C4CB971721D1}
//static const IID IID_IVaxServerSIP =
//{ 0x3db0f857, 0xbb81, 0x4371, { 0xa8, 0xc, 0xc4, 0xcb, 0x97, 0x17, 0x21, 0xd1 } };

BEGIN_INTERFACE_MAP(CVaxServerCOM, CCmdTarget)
	INTERFACE_PART(CVaxServerCOM, DIID__IVaxServerSIPEvents, Dispatch)
END_INTERFACE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVaxServerCOM message handlers

void CVaxServerCOM::UnLoadObjectCOM()
{
	if(m_pVaxSIP)
	{
		m_pVaxSIP->Release();
		m_pVaxSIP = NULL;
	}

	if(m_pVaxEvents)
	{
		LPUNKNOWN pUnk = GetIDispatch(FALSE);
		AfxConnectionUnadvise(m_pVaxEvents, DIID__IVaxServerSIPEvents, pUnk, FALSE, m_dwCookie);

		m_pVaxEvents->Release();
		m_pVaxEvents = NULL;
	}
}

BOOL CVaxServerCOM::LoadObjectCOM()
{
	UnLoadObjectCOM();

	CoInitialize(NULL);
	
	HRESULT hr = CoCreateInstance(CLSID_VaxServerSIP, NULL, CLSCTX_INPROC_SERVER, IID_IDispatch, (void**) &m_pVaxEvents);
	if(FAILED(hr)) return FALSE;

	m_pVaxEvents->QueryInterface(IID_IVaxServerSIP, (void**) &m_pVaxSIP);
	
	m_dwCookie = 1;
		
	LPUNKNOWN pUnk = GetIDispatch(FALSE);

	if(!AfxConnectionAdvise(m_pVaxEvents, DIID__IVaxServerSIPEvents, pUnk, FALSE, &m_dwCookie))
	{
		return FALSE;
	}

	return TRUE;
}

#define VAX_ERROR_LOAD_COM	"Unable to load VaxTeleServerCOM.dll COM component. Run command prompt as administrator, register the COM using regsvr32 command and try again.\n\n e.g. regsvr32 VaxTeleServerCOM.dll"

BOOL CVaxServerCOM::IsLoadedObjectCOM()
{
	if(m_pVaxSIP)
		return TRUE;
				
	OnVaxErrorLog("", -1, VAX_ERROR_LOAD_COM);
	return FALSE;
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

void CVaxServerCOM::SetLicenseKey(LPCTSTR sLicenseKey)
{
	if(!IsLoadedObjectCOM())
		return;

	m_pVaxSIP->SetLicenseKey(sLicenseKey);
}

void CVaxServerCOM::UnInitialize()
{
	m_bShowMsgBoxCOM = TRUE;
	
	if(!IsLoadedObjectCOM())
		return;
	
	m_pVaxSIP->UnInitialize();
}

BOOL CVaxServerCOM::Initialize(LPCTSTR sDomainRealm, LPCTSTR sSIPListenIP, LONG nSIPListenPort, LPCTSTR sRTPListenIP, LONG nRTPListenPort)
{
	if(!IsLoadedObjectCOM())
	{
		AfxMessageBox(VAX_ERROR_LOAD_COM);
		return FALSE;
	}
	
	return m_pVaxSIP->Initialize(sDomainRealm, sSIPListenIP, nSIPListenPort, sRTPListenIP, nRTPListenPort);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::AddUser(LPCTSTR sUserName, LPCTSTR sPassword, LPCTSTR sCodecList)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->AddUser(sUserName, sPassword, sCodecList);
}

void CVaxServerCOM::RemoveUser(LPCTSTR sUserName)
{
	if(!IsLoadedObjectCOM())
		return;

	m_pVaxSIP->RemoveUser(sUserName);
}

BOOL CVaxServerCOM::RegisterUserExpiry(LONG nExpiry)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->RegisterUserExpiry(nExpiry);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::AcceptRegister(LONG nRegId)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->AcceptRegister(nRegId);
}

BOOL CVaxServerCOM::RejectRegister(LONG nRegId, LONG nStatusCode, LPCTSTR sReasonPhrase)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->RejectRegister(nRegId, nStatusCode, sReasonPhrase);
}

BOOL CVaxServerCOM::AuthRegister(LONG nRegId)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->AuthRegister(nRegId);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::AddLine(LPCTSTR sLineName, LPCTSTR sDisplayName, LPCTSTR sUserName, LPCTSTR sAuthUser, LPCTSTR sAuthPwd, LPCTSTR sDomainRealm, LPCTSTR sProxySIP, LPCTSTR sOutboundProxySIP, LPCTSTR sCodecList)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->AddLine(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sOutboundProxySIP, sCodecList);
}

void CVaxServerCOM::RemoveLine(LPCTSTR sLineName)
{
	if(!IsLoadedObjectCOM())
		return;

	m_pVaxSIP->RemoveLine(sLineName);
}

BOOL CVaxServerCOM::RegisterLine(LPCTSTR sLineName, LONG nExpire)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->RegisterLine(sLineName, nExpire);
}

BOOL CVaxServerCOM::UnRegisterLine(LPCTSTR sLineName)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->UnRegisterLine(sLineName);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::AddDirectProxySIP(LPCTSTR sProxyName, LPCTSTR sAuthLogin, LPCTSTR sAuthPwd, LPCTSTR sDomainRealm, LPCTSTR sProxyIP, LONG nProxyPort, LPCTSTR sCodecList)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->AddDirectProxySIP(sProxyName, sAuthLogin, sAuthPwd, sDomainRealm, sProxyIP, nProxyPort, sCodecList);
}

void CVaxServerCOM::RemoveDirectProxySIP(LPCTSTR sProxyName)
{
	if(!IsLoadedObjectCOM())
		return;

	m_pVaxSIP->RemoveDirectProxySIP(sProxyName);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::AcceptCallSession(LONG nSessionId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sDialNo, LONG nToPeerType, LPCTSTR sToPeerName, LONG nTimeout)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->AcceptCallSession(nSessionId, sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName, nTimeout);
}

BOOL CVaxServerCOM::RejectCallSession(LONG nSessionId, LONG nStatusCode, LPCTSTR sReasonPhrase)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->RejectCallSession(nSessionId, nStatusCode, sReasonPhrase);
}

BOOL CVaxServerCOM::CloseCallSession(LONG nSessionId)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->CloseCallSession(nSessionId);
}

LONG CVaxServerCOM::DialCallSession(LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sDialNo, LONG nToPeerType, LPCTSTR sToPeerName, LONG nTimeout)
{
	if(!IsLoadedObjectCOM())
		return -1;

	return m_pVaxSIP->DialCallSession(sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName, nTimeout);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

LONG CVaxServerCOM::AcceptTransferBlind(LONG nTransfererSessionId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sTransferTo, LONG nToPeerType, LPCTSTR sToPeerName, LONG nTimeout)
{
	if(!IsLoadedObjectCOM())
		return -1;

	return m_pVaxSIP->AcceptTransferBlind(nTransfererSessionId, sCallerName, sCallerId, sTransferTo, nToPeerType, sToPeerName, nTimeout);
}

LONG CVaxServerCOM::AcceptTransferConsult(LONG nTransfererSessionId, LONG nTransferToSessionId)
{
	if(!IsLoadedObjectCOM())
		return -1;

	return m_pVaxSIP->AcceptTransferConsult(nTransfererSessionId, nTransferToSessionId);
}

void CVaxServerCOM::RejectTransfer(LONG nSessionId)
{
	if(!IsLoadedObjectCOM())
		return;

	m_pVaxSIP->RejectTransfer(nSessionId);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::PlayWaveStartToCallSession(LONG nSessionId, LONG nChannelId, LONG nWaveId, BOOL bLoopPlay, LONG nPlayPosPCM)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->PlayWaveStartToCallSession(nSessionId, nChannelId, nWaveId, bLoopPlay, nPlayPosPCM);
}

void CVaxServerCOM::PlayWaveStopToCallSession(LONG nSessionId, LONG nChannelId, LONG nWaveId)
{
	if(!IsLoadedObjectCOM())
		return;

	m_pVaxSIP->PlayWaveStopToCallSession(nSessionId, nChannelId, nWaveId);
}

BOOL CVaxServerCOM::PlayWaveSetVolumeToCallSession(LONG nSessionId, LONG nChannelId, LONG nWaveId, LONG nVolume)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->PlayWaveSetVolumeToCallSession(nSessionId, nChannelId, nWaveId, nVolume);
}

BOOL CVaxServerCOM::PlayWaveSetModeTypeToCallSession(LONG nSessionId, LONG nChannelId, LONG nPlayModeType)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->PlayWaveSetModeTypeToCallSession(nSessionId, nChannelId, nPlayModeType);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::RecordWaveStartToCallSession(LONG nSessionId, LONG nChannelId, LPCTSTR sFileName)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->RecordWaveStartToCallSession(nSessionId, nChannelId, sFileName);
}

void CVaxServerCOM::RecordWaveStopToCallSession(LONG nSessionId, LONG nChannelId)
{
	if(!IsLoadedObjectCOM())
		return;

	m_pVaxSIP->RecordWaveStopToCallSession(nSessionId, nChannelId);
}

BOOL CVaxServerCOM::RecordWavePauseToCallSession(LONG nSessionId, LONG nChannelId, BOOL bEnable)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->RecordWavePauseToCallSession(nSessionId, nChannelId, bEnable);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

LONG CVaxServerCOM::LoadWaveFile(LPCTSTR sFileName)
{
	if(!IsLoadedObjectCOM())
		return -1;

	return m_pVaxSIP->LoadWaveFile(sFileName);
}

LONG CVaxServerCOM::LoadWavePCM(char* pDataPCM, LONG nSizePCM)
{
	if(!IsLoadedObjectCOM())
		return -1;

	return m_pVaxSIP->LoadWavePCM((LONGLONG) pDataPCM, nSizePCM, 0);
}

void CVaxServerCOM::UnLoadWaveFile(LONG nWaveId)
{
	if(!IsLoadedObjectCOM())
		return;

	m_pVaxSIP->UnLoadWaveFile(nWaveId);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::LoadMusicHold(LPCTSTR sFileName)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->LoadMusicHold(sFileName);
}

void CVaxServerCOM::UnLoadMusicHold()
{
	if(!IsLoadedObjectCOM())
		return;

	m_pVaxSIP->UnLoadMusicHold();
}

BOOL CVaxServerCOM::AcceptOnHoldRequest(LONG nSessionId)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->AcceptOnHoldRequest(nSessionId);
}

BOOL CVaxServerCOM::AcceptOffHoldRequest(LONG nSessionId)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->AcceptOffHoldRequest(nSessionId);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////


BOOL CVaxServerCOM::AcceptChatMessage(LONG nChatMsgId, LONG nToPeerType, LPCTSTR sToPeerName)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->AcceptChatMessage(nChatMsgId, nToPeerType, sToPeerName);
}

void CVaxServerCOM::RejectChatMessage(LONG nChatMsgId, LONG nStatusCode, LPCTSTR sReasonPhrase)
{
	if(!IsLoadedObjectCOM())
		return;

	m_pVaxSIP->RejectChatMessage(nChatMsgId, nStatusCode, sReasonPhrase);
}

BOOL CVaxServerCOM::AcceptChatStatusSubscribe(LONG nSubscrbId, LPCTSTR sMsgFrom, LPCTSTR sMsgTo, LONG nToPeerType, LPCTSTR sToPeerName)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->AcceptChatStatusSubscribe(nSubscrbId, sMsgFrom, sMsgTo, nToPeerType, sToPeerName);
}

void CVaxServerCOM::RejectChatStatusSubscribe(LONG nSubscrbId, LPCTSTR sMsgFrom, LPCTSTR sMsgTo)
{
	if(!IsLoadedObjectCOM())
		return;

	m_pVaxSIP->RejectChatStatusSubscribe(nSubscrbId, sMsgFrom, sMsgTo);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::OpenConferenceRoom(LPCTSTR sRoomName)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->OpenConferenceRoom(sRoomName);
}

void CVaxServerCOM::CloseConferenceRoom(LPCTSTR sRoomName)
{
	if(!IsLoadedObjectCOM())
		return;

	m_pVaxSIP->CloseConferenceRoom(sRoomName);
}

BOOL CVaxServerCOM::AddCallSessionToConferenceRoom(LPCTSTR sRoomName, LONG nSessionId, LONG nVoiceTypeId)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->AddCallSessionToConferenceRoom(sRoomName, nSessionId, nVoiceTypeId);
}

BOOL CVaxServerCOM::RemoveCallSessionFromConferenceRoom(LONG nSessionId)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->RemoveCallSessionFromConferenceRoom(nSessionId);
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::PlayWaveStartToConferenceRoom(LPCTSTR sRoomName, LONG nWaveId, BOOL bLoopPlay, LONG nPlayPosPCM)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->PlayWaveStartToConferenceRoom(sRoomName, nWaveId, bLoopPlay, nPlayPosPCM);
}

BOOL CVaxServerCOM::PlayWaveStopToConferenceRoom(LPCTSTR sRoomName, LONG nWaveId)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->PlayWaveStopToConferenceRoom(sRoomName, nWaveId);
}

BOOL CVaxServerCOM::RecordWaveStartToConferenceRoom(LPCTSTR sRoomName, LPCTSTR sFileName)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->RecordWaveStartToConferenceRoom(sRoomName, sFileName);
}

BOOL CVaxServerCOM::RecordWaveStopToConferenceRoom(LPCTSTR sRoomName)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->RecordWaveStopToConferenceRoom(sRoomName);
}

BOOL CVaxServerCOM::RecordWavePauseToConferenceRoom(LPCTSTR sRoomName, BOOL bEnable)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->RecordWavePauseToConferenceRoom(sRoomName, bEnable);
}


///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::DialToneToCallSession(BOOL bEnable, LONG nSessionId, LONG nWaveId)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->DialToneToCallSession(bEnable, nSessionId, nWaveId);
}

BOOL CVaxServerCOM::VoiceSessionLost(BOOL bEnable, LONG nTimeout)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->VoiceSessionLost(bEnable, nTimeout);
}

LONG CVaxServerCOM::SendInfoVM(LPCTSTR sUserLogin, LONG nNewMsgCount, LONG nOldMsgCount, BOOL bMsgWaiting)
{
	if(!IsLoadedObjectCOM())
		return -1;

	return m_pVaxSIP->SendInfoVM(sUserLogin, nNewMsgCount, nOldMsgCount, bMsgWaiting);
}

BOOL CVaxServerCOM::StartVaxTeleTick(LONG nTickId, LONG nElapse)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->StartVaxTeleTick(nTickId, nElapse);
}

BOOL CVaxServerCOM::StopVaxTeleTick(LONG nTickId)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->StopVaxTeleTick(nTickId);
}

BOOL CVaxServerCOM::SetUserAgentName(LPCTSTR sName)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->SetUserAgentName(sName);
}

CString CVaxServerCOM::GetUserAgentName()
{
	if(!IsLoadedObjectCOM())
		return "";

	CString sResult = (LPCTSTR) m_pVaxSIP->GetUserAgentName();
	return sResult;
}
	
BOOL CVaxServerCOM::SetSessionNameSDP(LPCTSTR sName)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->SetSessionNameSDP(sName);
}

CString CVaxServerCOM::GetSessionNameSDP()
{
	if(!IsLoadedObjectCOM())
		return "";

	CString sResult = (LPCTSTR) m_pVaxSIP->GetSessionNameSDP();
	return sResult;
}

BOOL CVaxServerCOM::SendDTMFCallSession(LONG nSessionId, LONG nChannelId, LONG nTypeDTMF, LONG nDigit)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->SendDTMFCallSession(nSessionId, nChannelId, nTypeDTMF, nDigit);
}

BOOL CVaxServerCOM::DetectDigitDTMF(LONG nSessionId, LONG nChannelId, LONG nTypeDTMF, BOOL bEnable, LONG nMilliSecTimeout)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->DetectDigitDTMF(nSessionId, nChannelId, nTypeDTMF, bEnable, nMilliSecTimeout);
}

LONG CVaxServerCOM::GetVaxErrorCode()
{
	if(!IsLoadedObjectCOM())
		return -1;

	return  m_pVaxSIP->GetVaxErrorCode();
}

BOOL CVaxServerCOM::DiagnosticLogSIP(BOOL bInbound, BOOL bOutbound)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->DiagnosticLogSIP(bInbound, bOutbound);
}


/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

LONG CVaxServerCOM::SplitCallSession(LONG nSessionId, LONG nChannelId)
{
	if(!IsLoadedObjectCOM())
		return -1;

	return m_pVaxSIP->SplitCallSession(nSessionId, nChannelId);
}

BOOL CVaxServerCOM::MoveCall(LONG nSrcSessionId, LONG nSrcChannelId, LONG nDscSessionId)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->MoveCall(nSrcSessionId, nSrcChannelId, nDscSessionId);
}

BOOL CVaxServerCOM::CallSessionSendStatusResponse(LONG nSessionId, LONG nStatusCode, LPCTSTR sReasonPhrase, LPCTSTR sContactURI)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->CallSessionSendStatusResponse(nSessionId, nStatusCode, sReasonPhrase, sContactURI);
}

BOOL CVaxServerCOM::CallSessionDetectAMD(LONG nSessionId, LONG nChannelId, BOOL bEnable, LONG nAnalysisTime, LONG nSilenceTime, LONG nSilenceCount)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->CallSessionDetectAMD(nSessionId, nChannelId, bEnable, nAnalysisTime, nSilenceTime, nSilenceCount);
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::AddCustomHeader(LONG nReqId, LPCTSTR sName, LPCTSTR sValue)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->AddCustomHeader(nReqId, sName, sValue);
}

BOOL CVaxServerCOM::RemoveCustomHeader(LONG nReqId, LPCTSTR sName)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->RemoveCustomHeader(nReqId, sName);
}

BOOL CVaxServerCOM::RemoveCustomHeaderAll(LONG nReqId)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->RemoveCustomHeaderAll(nReqId);
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

LONG CVaxServerCOM::GetCallSessionTxCodec(LONG nSessionId, LONG nChannelId)
{
	if(!IsLoadedObjectCOM())
		return -1;

	return m_pVaxSIP->GetCallSessionTxCodec(nSessionId, nChannelId);
}

LONG CVaxServerCOM::GetCallSessionRxCodec(LONG nSessionId, LONG nChannelId)
{
	if(!IsLoadedObjectCOM())
		return -1;

	return m_pVaxSIP->GetCallSessionRxCodec(nSessionId, nChannelId);
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::BusyLampSubscribeAccept(LONG nSubScrbId, BOOL bAuthenticate, LONG nExpires)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->BusyLampSubscribeAccept(nSubScrbId, bAuthenticate, nExpires);
}

BOOL CVaxServerCOM::BusyLampSubscribeReject(LONG nSubScrbId, LONG nStatusCode, LPCTSTR sReasonPhrase)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->BusyLampSubscribeReject(nSubScrbId, nStatusCode, CString(sReasonPhrase).AllocSysString());
}

BOOL CVaxServerCOM::BusyLampSendStatus(LPCTSTR sFromUserName, LPCTSTR sToUserName, LONG nStateId)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->BusyLampSendStatus(sFromUserName, sToUserName, nStateId);
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::SetCallSessionData(LONG nSessionId, HANDLE hCustomData)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->SetCallSessionData(nSessionId, (LONGLONG) hCustomData);
}

HANDLE CVaxServerCOM::GetCallSessionData(LONG nSessionId)
{
	if(!IsLoadedObjectCOM())
		return NULL;

	return (HANDLE) m_pVaxSIP->GetCallSessionData(nSessionId);
}
		
BOOL CVaxServerCOM::SetUserData(LPCTSTR sUserName, HANDLE hCustomData)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->SetUserData(sUserName, (LONGLONG) hCustomData);
}

HANDLE CVaxServerCOM::GetUserData(LPCTSTR sUserName)
{
	if(!IsLoadedObjectCOM())
		return NULL;

	return (HANDLE) m_pVaxSIP->GetUserData(sUserName);
}

BOOL CVaxServerCOM::SetLineData(LPCTSTR sLineName, HANDLE hCustomData)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->SetLineData(sLineName, (LONGLONG) hCustomData);
}

HANDLE CVaxServerCOM::GetLineData(LPCTSTR sLineName)
{
	if(!IsLoadedObjectCOM())
		return NULL;

	return (HANDLE) m_pVaxSIP->GetLineData(sLineName);
}

BOOL CVaxServerCOM::SetDirectProxyData(LPCTSTR sProxyName, HANDLE hCustomData)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->SetDirectProxyData(sProxyName, (LONGLONG) hCustomData);
}
	
HANDLE CVaxServerCOM::GetDirectProxyData(LPCTSTR sProxyName)
{
	if(!IsLoadedObjectCOM())
		return NULL;

	return (HANDLE) m_pVaxSIP->GetDirectProxyData(sProxyName);
}

BOOL CVaxServerCOM::SetConferenceRoomData(LPCTSTR sRoomName, HANDLE hCustomData)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->SetConferenceRoomData(sRoomName, (LONGLONG) hCustomData);
}

HANDLE CVaxServerCOM::GetConferenceRoomData(LPCTSTR sRoomName)
{
	if(!IsLoadedObjectCOM())
		return NULL;

	return (HANDLE) m_pVaxSIP->GetConferenceRoomData(sRoomName);
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::TrvsUserStart()
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->TrvsUserStart();
}

CString CVaxServerCOM::TrvsUserNext()
{
	if(!IsLoadedObjectCOM())
		return "";

	CString sResult = (LPCTSTR) m_pVaxSIP->TrvsUserNext();
	return sResult;
}

BOOL CVaxServerCOM::TrvsLineStart()
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->TrvsLineStart();
}

CString CVaxServerCOM::TrvsLineNext()
{
	if(!IsLoadedObjectCOM())
		return "";

	CString sResult = (LPCTSTR) m_pVaxSIP->TrvsLineNext();
	return sResult;
}

BOOL CVaxServerCOM::TrvsDirectProxyStart()
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->TrvsDirectProxyStart();
}

CString CVaxServerCOM::TrvsDirectProxyNext()
{
	if(!IsLoadedObjectCOM())
		return "";

	CString sResult = (LPCTSTR) m_pVaxSIP->TrvsDirectProxyNext();
	return sResult;
}

BOOL CVaxServerCOM::TrvsCallSessionStart()
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->TrvsCallSessionStart();
}

LONG CVaxServerCOM::TrvsCallSessionNext()
{
	if(!IsLoadedObjectCOM())
		return -1;

	return m_pVaxSIP->TrvsCallSessionNext();
}

BOOL CVaxServerCOM::TrvsConferenceRoomStart()
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->TrvsConferenceRoomStart();
}

CString CVaxServerCOM::TrvsConferenceRoomNext()
{
	if(!IsLoadedObjectCOM())
		return "";

	CString sResult = (LPCTSTR) m_pVaxSIP->TrvsConferenceRoomNext();
	return sResult;
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

LONG CVaxServerCOM::GetCallCount()
{
	if(!IsLoadedObjectCOM())
		return 0;

	return m_pVaxSIP->GetCallCount();
}

LONG CVaxServerCOM::GetUserCount()
{
	if(!IsLoadedObjectCOM())
		return 0;

	return m_pVaxSIP->GetUserCount();
}

LONG CVaxServerCOM::GetLineCount()
{
	if(!IsLoadedObjectCOM())
		return 0;

	return m_pVaxSIP->GetLineCount();
}

LONG CVaxServerCOM::GetDirectProxyCount()
{
	if(!IsLoadedObjectCOM())
		return 0;

	return m_pVaxSIP->GetDirectProxyCount();
}

LONG CVaxServerCOM::GetCallSessionCount()
{
	if(!IsLoadedObjectCOM())
		return 0;

	return m_pVaxSIP->GetCallSessionCount();
}

LONG CVaxServerCOM::GetConferenceRoomCount()
{
	if(!IsLoadedObjectCOM())
		return 0;

	return m_pVaxSIP->GetConferenceRoomCount();
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

LONG CVaxServerCOM::CustomListOpen(LONG nTableSize)
{
	if(!IsLoadedObjectCOM())
		return -1;

	return m_pVaxSIP->CustomListOpen(nTableSize);
}

BOOL CVaxServerCOM::CustomListClose(LONG nListId)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->CustomListClose(nListId);
}
	
BOOL CVaxServerCOM::CustomListAddData(LONG nListId, LPCTSTR sKey, HANDLE hCustomData)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->CustomListAddData(nListId, CString(sKey).AllocSysString(), (LONGLONG) hCustomData);
}

BOOL CVaxServerCOM::CustomListRemoveData(LONG nListId, LPCTSTR sKey)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->CustomListRemoveData(nListId, CString(sKey).AllocSysString());
}

HANDLE CVaxServerCOM::CustomListFindData(LONG nListId, LPCTSTR sKey)
{
	if(!IsLoadedObjectCOM())
		return NULL;

	return (HANDLE) m_pVaxSIP->CustomListFindData(nListId, CString(sKey).AllocSysString());
}

LONG CVaxServerCOM::CustomListCount(LONG nListId)
{
	if(!IsLoadedObjectCOM())
		return 0;

	return m_pVaxSIP->CustomListCount(nListId);
}

BOOL CVaxServerCOM::CustomListReset(LONG nListId)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->CustomListReset(nListId);
}

BOOL CVaxServerCOM::CustomListTrvsStart(LONG nListId)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->CustomListTrvsStart(nListId);
}

HANDLE CVaxServerCOM::CustomListTrvsNext(LONG nListId)
{
	if(!IsLoadedObjectCOM())
		return NULL;

	return (HANDLE) m_pVaxSIP->CustomListTrvsNext(nListId);
}

CString CVaxServerCOM::GetCallSessionHeaderCallId(LONG nSessionId, LONG nChannelId)
{
	if(!IsLoadedObjectCOM())
		return "";

	CString sResult = (LPCTSTR) m_pVaxSIP->GetCallSessionHeaderCallId(nSessionId, nChannelId);
	return sResult;
}

BOOL CVaxServerCOM::SetListenPortRangeRTP(LONG nListenStartPort, LONG nListenEndPort)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->SetListenPortRangeRTP(nListenStartPort, nListenEndPort);
}

BOOL CVaxServerCOM::CallSessionMuteVoice(LONG nSessionId, LONG nChannelId, BOOL bListen, BOOL bSpeak)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->CallSessionMuteVoice(nSessionId, nChannelId, bListen, bSpeak);
}

BOOL CVaxServerCOM::VideoCOMM(BOOL bEnable)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->VideoCOMM(bEnable);
}

/////////////////////////////////////////////////////////////////////////////////////
////////////////////////////      RingGroup       ///////////////////////////////////

BOOL CVaxServerCOM::AddRingGroup(LPCTSTR sGroupName)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->AddRingGroup(sGroupName);
}

void CVaxServerCOM::RemoveRingGroup(LPCTSTR sGroupName)
{
	if(!IsLoadedObjectCOM())
		return;

	m_pVaxSIP->RemoveRingGroup(sGroupName);
}

BOOL CVaxServerCOM::AddRingGroupAgent(LPCTSTR sGroupName, LPCTSTR sUserName)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->AddRingGroupAgent(sGroupName, sUserName);
}

void CVaxServerCOM::RemoveRingGroupAgent(LPCTSTR sGroupName, LPCTSTR sUserName)
{
	if(!IsLoadedObjectCOM())
		return;

	m_pVaxSIP->RemoveRingGroupAgent(sGroupName, sUserName);
}

void CVaxServerCOM::SetRingGroupProcessMode(LPCTSTR sGroupName, LONG nProcessMode, LONG nProcessType)
{
	if(!IsLoadedObjectCOM())
		return;

	m_pVaxSIP->SetRingGroupProcessMode(sGroupName, nProcessMode, nProcessType);
}

BOOL CVaxServerCOM::SetRingGroupAgentPriority(LPCTSTR sGroupName, LPCTSTR sAgentName, LONG nPriority)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->SetRingGroupAgentPriority(sGroupName, sAgentName, nPriority);
}

BOOL CVaxServerCOM::AddCallSessionToRingGroup(LPCTSTR sGroupName, LPCTSTR sCallerName, LPCTSTR sCallerId, LONG nSessionId)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->AddCallSessionToRingGroup(sGroupName, sCallerName, sCallerId, nSessionId);
}

/////////////////////////////////////////////////////////////////////////////////////
////////////////////////////      Queue       ///////////////////////////////////////

BOOL CVaxServerCOM::AddQueue(LPCTSTR sQueueName)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->AddQueue(sQueueName);
}

void CVaxServerCOM::RemoveQueue(LPCTSTR sQueueName)
{
	if(!IsLoadedObjectCOM())
		return;

	m_pVaxSIP->RemoveQueue(sQueueName);
}

BOOL CVaxServerCOM::AddQueueAgent(LPCTSTR sQueueName, LPCTSTR sAgentName)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->AddQueueAgent(sQueueName, sAgentName);
}

void CVaxServerCOM::RemoveQueueAgent(LPCTSTR sQueueName, LPCTSTR sAgentName)
{
	if(!IsLoadedObjectCOM())
		return;

	m_pVaxSIP->RemoveQueueAgent(sQueueName, sAgentName);
}

void CVaxServerCOM::SetQueueAgentPriority(LPCTSTR sQueueName, LPCTSTR sAgentName, LONG nPriority)
{
	if(!IsLoadedObjectCOM())
		return;

	m_pVaxSIP->SetQueueAgentPriority(sQueueName, sAgentName, nPriority);
}

BOOL CVaxServerCOM::SetQueueAgentStatus(LPCTSTR sQueueName, LPCTSTR sAgentName, LONG nStatusId)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->SetQueueAgentStatus(sQueueName, sAgentName, nStatusId);
}

void CVaxServerCOM::SetQueueProcessMode(LPCTSTR sQueueName, LONG nProcessMode, LONG nProcessType)
{
	if(!IsLoadedObjectCOM())
		return;
	
	m_pVaxSIP->SetQueueProcessMode(sQueueName, nProcessMode, nProcessType);
}
	
BOOL CVaxServerCOM::AddCallSessionToQueue(LPCTSTR sQueueName, LPCTSTR sCallerName, LPCTSTR sCallerId, LONG nSessionId, LONG nTimeout)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->AddCallSessionToQueue(sQueueName, sCallerName, sCallerId, nSessionId, nTimeout);
}

BOOL CVaxServerCOM::RemoveCallSessionFromQueue(LONG nSessionId)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->RemoveCallSessionFromQueue(nSessionId);
}

/////////////////////////////////////////////////////////////////////////////////////
////////////////////////////      CallPickUp       //////////////////////////////////

BOOL CVaxServerCOM::AddCallPickUpGroup(LPCTSTR sGroupName)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->AddCallPickUpGroup(sGroupName);
}

void CVaxServerCOM::RemoveCallPickUpGroup(LPCTSTR sGroupName)
{
	if(!IsLoadedObjectCOM())
		return;

	m_pVaxSIP->RemoveCallPickUpGroup(sGroupName);
}

BOOL CVaxServerCOM::AddCallPickUpGroupMember(LPCTSTR sGroupName, LPCTSTR sUserName)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->AddCallPickUpGroupMember(sGroupName, sUserName);
}

void CVaxServerCOM::RemoveCallPickUpGroupMember(LPCTSTR sGroupName, LPCTSTR sUserName)
{
	if(!IsLoadedObjectCOM())
		return;

	m_pVaxSIP->AddCallPickUpGroupMember(sGroupName, sUserName);
}

BOOL CVaxServerCOM::PickUpCall(LONG nSessionId, LPCTSTR sUserName)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->PickUpCall(nSessionId, sUserName);
}

////////////////////////////////////////////////////////////////////////////////////
////////////////////////////      CallParking     //////////////////////////////////

BOOL CVaxServerCOM::ParkCallSession(LONG nSessionId, LONG nChannelId, LONG nSlotId)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->ParkCallSession(nSessionId, nChannelId, nSlotId);
}

BOOL CVaxServerCOM::ConnectToParkedCall(LONG nSessionId, LONG nChannelId, LONG nSlotId)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->ConnectToParkedCallSession(nSessionId, nChannelId, nSlotId);
}

////////////////////////////////////////////////////////////////////////////////////
////////////////////////////      StealthListen   //////////////////////////////////

BOOL CVaxServerCOM::AddStealthListener(LONG nStealthSessionId, LONG nCapturePeerType, LPCTSTR sCapturePeerName, LONG nVoiceTypeId)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->AddStealthListener(nStealthSessionId, nCapturePeerType, sCapturePeerName, nVoiceTypeId);
}
	
////////////////////////////////////////////////////////////////////////////////////
////////////////////////////   SIP REC   ///////////////////////////////////////////

BOOL CVaxServerCOM::SetExtDataREC(LONG nSessionId, LONG nChannelId, LPCTSTR sExtData)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->SetExtDataREC(nSessionId, nChannelId, sExtData);
}

BOOL CVaxServerCOM::ConnectToServerREC(LONG nSessionId, LONG nChannelId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sDialNo, LONG nToPeerType, LPCTSTR sToPeerName, LONG nTimeout)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->ConnectToServerREC(nSessionId, nChannelId, sCallerName, sCallerId, sDialNo, nToPeerType, sToPeerName, nTimeout);
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

BOOL CVaxServerCOM::AdjustCallSessionVoiceType(LONG nSessionId, LONG nChannelId, LONG nVoiceTypeId)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->AdjustCallSessionVoiceType(nSessionId, nChannelId, nVoiceTypeId);
}

BOOL CVaxServerCOM::AddNetworkRouteSIP(LPCTSTR sAssignedIP, LPCTSTR sRouterIP)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->AddNetworkRouteSIP(sAssignedIP, sRouterIP);
}

BOOL CVaxServerCOM::AddNetworkRouteRTP(LPCTSTR sAssignedIP, LPCTSTR sRouterIP)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->AddNetworkRouteRTP(sAssignedIP, sRouterIP);
}

BOOL CVaxServerCOM::RefreshCallSession(LONG nSessionId, LONG nChannelId, LPCTSTR sCallerName, LPCTSTR sCallerId, LONG nTimeout)
{
	if(!IsLoadedObjectCOM())
		return FALSE;

	return m_pVaxSIP->RefreshCallSession(nSessionId, nChannelId, sCallerName, sCallerId, nTimeout);
}

LONG CVaxServerCOM::SendNotifyMsgSIP(LPCTSTR sMsgFrom, LPCTSTR sMsgTo, LONG nToPeerType, LPCTSTR sToPeerName)
{
	if(!IsLoadedObjectCOM())
		return -1;

	return m_pVaxSIP->SendNotifyMsgSIP(sMsgFrom, sMsgTo, nToPeerType, sToPeerName);
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

void CVaxServerCOM::OnRegisterUser(LPCTSTR sUserLogin, LPCTSTR sDomain, LPCTSTR sUserAgent, LPCTSTR sFromIP, LONG nFromPort, LONG nRegId) {}
void CVaxServerCOM::OnRegisterUserSuccess(LPCTSTR sUserLogin, LPCTSTR sFromIP, LONG nFromPort, LONG nRegId) {}
void CVaxServerCOM::OnRegisterUserFailed(LPCTSTR sUserLogin, LPCTSTR sFromIP, LONG nFromPort, LONG nRegId) {}
void CVaxServerCOM::OnUnRegisterUser(LPCTSTR sUserLogin) {}
		
void CVaxServerCOM::OnCallSessionConnecting(LONG nSessionId, LONG nChannelId, LONG nStatusCode, LPCTSTR sReasonPhrase) {}
void CVaxServerCOM::OnCallSessionFailed(LONG nSessionId, LONG nChannelId, LONG nStatusCode, LPCTSTR sReasonPhrase) {}
void CVaxServerCOM::OnCallSessionConnected(LONG nSessionId) {}

void CVaxServerCOM::OnIncomingCall(LONG nSessionId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sDialNo, LONG nFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sUserAgent, LPCTSTR sFromIP, LONG nFromPort) {}
	
void CVaxServerCOM::OnCallSessionCreated(LONG nSessionId, LONG nReasonCode) {}
void CVaxServerCOM::OnCallSessionClosed(LONG nSessionId, LONG nChannelId, LONG nReasonCode) {}

void CVaxServerCOM::OnCallSessionLost(LONG nSessionId, LONG nChannelId) {}
void CVaxServerCOM::OnCallSessionHangup(LONG nSessionId, LONG nChannelId) {}
void CVaxServerCOM::OnCallSessionTimeout(LONG nSessionId, LONG nChannelId) {}
void CVaxServerCOM::OnCallSessionCancelled(LONG nSessionId) {}
	
void CVaxServerCOM::OnCallSessionOnHold(LONG nSessionId, LONG nChannelId) {}
void CVaxServerCOM::OnCallSessionOffHold(LONG nSessionId, LONG nChannelId) {}

void CVaxServerCOM::OnCallSessionTransferBlind(LONG nTransfererSessionId, LONG nTransfererChannelId, LPCTSTR sTransferer, LPCTSTR sTransferee, LPCTSTR sTransferTo) {}
void CVaxServerCOM::OnCallSessionTransferConsult(LONG nTransfererSessionId, LONG nTransfereeSessionId, LONG nTransferToSessionId, LONG nTransfererChannelId, LONG nTransfereeChannelId, LONG nTransferToChannelId, LPCTSTR sTransferer, LPCTSTR sTransferee, LPCTSTR sTransferTo) {}
	
void CVaxServerCOM::OnCallSessionTransfering(LONG nSessionId, LONG nTransferType, LONG nChannelId, LONG nStatusCode, LPCTSTR sReasonPhrase) {}
void CVaxServerCOM::OnCallSessionTransferFailed(LONG nSessionId, LONG nTransferType, LONG nChannelId, LONG nStatusCode, LPCTSTR sReasonPhrase) {}
void CVaxServerCOM::OnCallSessionTransferTimeout(LONG nSessionId, LONG nTransferType, LONG nChannelId) {}
void CVaxServerCOM::OnCallSessionTransfered(LONG nSessionId, LONG nTransferType) {}

void CVaxServerCOM::OnLineRegisterTrying(LPCTSTR sLineName) {}
void CVaxServerCOM::OnLineRegisterFailed(LPCTSTR sLineName, LONG nStatusCode, LPCTSTR sReasonPhrase) {}
void CVaxServerCOM::OnLineRegisterSuccess(LPCTSTR sLineName) {}

void CVaxServerCOM::OnLineUnRegisterTrying(LPCTSTR sLineName) {}
void CVaxServerCOM::OnLineUnRegisterFailed(LPCTSTR sLineName, LONG nStatusCode, LPCTSTR sReasonPhrase) {}
void CVaxServerCOM::OnLineUnRegisterSuccess(LPCTSTR sLineName) {}
		
void CVaxServerCOM::OnChatMessageText(LONG nChatMsgId, LPCTSTR sMsgFrom, LPCTSTR sMsgTo, LPCTSTR sMsgText, LONG nFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sFromIP, LONG nFromPort) {}
void CVaxServerCOM::OnChatMessageTyping(LONG nChatMsgId, LPCTSTR sMsgFrom, LPCTSTR sMsgTo, BOOL IsTypingStart, LONG nFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sFromIP, LONG nFromPort) {}
	
void CVaxServerCOM::OnChatStatusSubscribe(LONG nSubscrbId, LPCTSTR sMsgFrom, LPCTSTR sMsgTo, LONG nFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sFromIP, LONG nFromPort) {}
void CVaxServerCOM::OnChatStatusSendSubscribeSuccess(LONG nSubscrbId) {}
void CVaxServerCOM::OnChatStatusSendSubscribeFailed(LONG nSubscrbId, LONG nStatusCode, LPCTSTR sReasonPhrase) {}

void CVaxServerCOM::OnChatMessageSuccess(LONG nChatMsgId) {}
void CVaxServerCOM::OnChatMessageFailed(LONG nChatMsgId, LONG nStatusId, LPCTSTR sReasonPhrase) {}
void CVaxServerCOM::OnChatMessageTimeout(LONG nChatMsgId) {}

void CVaxServerCOM::OnOutgoingDiagnosticLog(LPCTSTR sMsgSIP, LPCTSTR sToIP, LONG nToPort) {}
void CVaxServerCOM::OnIncomingDiagnosticLog(LPCTSTR sMsgSIP, LPCTSTR sFromIP, LONG nFromPort) {}

void CVaxServerCOM::OnDetectedDigitDTMF(LONG nSessionId, LONG nChannelId, LPCTSTR sDigitDTMF) {}
void CVaxServerCOM::OnVaxTeleTick(LONG nTickId) {}

void CVaxServerCOM::OnSendTimeoutVM(LONG nMsgIdVM) {}
void CVaxServerCOM::OnSendSuccessVM(LONG nMsgIdVM) {}

void CVaxServerCOM::OnCallSessionDialToneStart(LONG nSessionId, LONG nChannelId, LONG nWaveId) {}
void CVaxServerCOM::OnCallSessionDialToneStop(LONG nSessionId, LONG nChannelId, LONG nWaveId) {}

void CVaxServerCOM::OnCallSessionPlayWaveDone(LONG nSessionId, LONG nChannelId, LONG nWaveId) {}
void CVaxServerCOM::OnConferenceRoomPlayWaveDone(LPCTSTR sRoomName, LONG nWaveId) {}
		
void CVaxServerCOM::OnCallSessionDetectedAMD(LONG nSessionId, LONG nChannelId, BOOL bIsHuman) {}

void CVaxServerCOM::OnCallSessionRecordedPCM(LONG nSessionId, LONG nChannelId, LONGLONG nDataPCM, LONG nSizePCM, LONG nTypePCM) {}
void CVaxServerCOM::OnConferenceRoomRecordedPCM(LPCTSTR sRoomName, LONGLONG nDataPCM, LONG nSizePCM, LONG nTypePCM) {}

void CVaxServerCOM::OnBusyLampSubscribe(LONG nSubScrbId, LPCTSTR sUserName, LPCTSTR sToUserName, LPCTSTR sFromIP, LONG nFromPort) {}
void CVaxServerCOM::OnBusyLampUnSubscribe(LONG nSubScrbId, LPCTSTR sUserName, LPCTSTR sToUserName, LPCTSTR sFromIP, LONG nFromPort) {}
void CVaxServerCOM::OnBusyLampSubscribeSuccess(LONG nSubScrbId, LPCTSTR sUserName) {}
void CVaxServerCOM::OnBusyLampSubscribeFailed(LONG nSubScrbId, LPCTSTR sUserName) {}
void CVaxServerCOM::OnBusyLampSendStatus(LPCTSTR sFromUserName, LPCTSTR sToUserName, LONG nStateId) {}

void CVaxServerCOM::OnVaxErrorLog(LPCTSTR sFuncName, LONG nErrorCode, LPCTSTR sErrorMsg) {}
void CVaxServerCOM::OnVaxLicenseChannel(LONG nTotalChannels, LONG nUsedChannels) {}
	
void CVaxServerCOM::OnAddCallSessionToQueueSuccess(LPCTSTR sQueueName, LONG nSessionId) {}
void CVaxServerCOM::OnAddCallSessionToQueueFailed(LPCTSTR sQueueName, LONG nSessionId) {}

void CVaxServerCOM::OnQueuePlayWaveStart(LONG nEventType, LPCTSTR sQueueName, LONG nSessionId) {}
void CVaxServerCOM::OnQueuePlayWaveStop(LONG nEventType, LPCTSTR sQueueName, LONG nSessionId) {}

void CVaxServerCOM::OnQueueAgentConnectStarted(LPCTSTR sQueueName, LPCTSTR sAgentName, LONG nSessionId) {}
void CVaxServerCOM::OnQueueAgentConnectTrying(LPCTSTR sQueueName, LPCTSTR sAgentName, LONG nSessionId, LONG nStatusCode, LPCTSTR sReasonPhrase) {}
void CVaxServerCOM::OnQueueAgentConnectFailed(LPCTSTR sQueueName, LPCTSTR sAgentName, LONG nSessionId, LONG nStatusCode, LPCTSTR sReasonPhrase) {}
void CVaxServerCOM::OnQueueAgentConnectTimeout(LPCTSTR sQueueName, LPCTSTR sAgentName, LONG nSessionId) {}
void CVaxServerCOM::OnQueueAgentConnectSuccess(LPCTSTR sQueueName, LPCTSTR sAgentName, LONG nSessionId) {}
	
void CVaxServerCOM::OnAddCallSessionToRingGroupSuccess(LPCTSTR sGroupName, LONG nSessionId) {}
void CVaxServerCOM::OnAddCallSessionToRingGroupFailed(LPCTSTR sGroupName, LONG nSessionId) {}

void CVaxServerCOM::OnServerConnectingREC(LONG nSessionId, LONG nChannelId, LONG nStatusCode, LPCTSTR sReasonPhrase) {}
void CVaxServerCOM::OnServerConnectedREC(LONG nSessionId, LONG nChannelId) {}
void CVaxServerCOM::OnServerFailedREC(LONG nSessionId, LONG nChannelId, LONG nStatusCode, LPCTSTR sReasonPhrase) {}
void CVaxServerCOM::OnServerTimeoutREC(LONG nSessionId, LONG nChannelId) {}
void CVaxServerCOM::OnServerHungupREC(LONG nSessionId, LONG nChannelId) {}

void CVaxServerCOM::OnSendReqTransferCallTimeout(LONG nSessionId, LONG nChannelId) {}
void CVaxServerCOM::OnSendReqTransferCallAccepted(LONG nSessionId, LONG nChannelId) {}
void CVaxServerCOM::OnSendReqTransferCallFailed(LONG nSessionId, LONG nChannelId, LONG nStatusCode, LPCTSTR sReasonPhrase) {}

void CVaxServerCOM::OnQualityReportPUBLISH(LPCTSTR sMsgSIP, LPCTSTR sMsgSDP, LPCTSTR sFromIP, LONG nFromPort) {}

void CVaxServerCOM::OnSendNotifyMsgSuccess(LONG nMsgId) {}
void CVaxServerCOM::OnSendNotifyMsgFailed(LONG nMsgId, LONG nStatusCode, LPCTSTR sReasonPhrase) {}