#include "StdAfx.h"
#include "StoreUser.h"

#define SUB_KEY_BUFFER_SIZE	2000

#define ROOT_PATH	"Users\\"

CStoreUser::CStoreUser(void)
{
	
}

CStoreUser::~CStoreUser(void)
{
	
}

BOOL CStoreUser::AddUser(LPCTSTR sUserName, LPCTSTR sPassword, LPCTSTR sCodecList, BOOL bBlocked)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s", ROOT_PATH, sUserName);

	CStoreRegistry::SetTEXT(sKeyPath, "UserName", sUserName);
	CStoreRegistry::SetTEXT(sKeyPath, "Password", sPassword);
	CStoreRegistry::SetTEXT(sKeyPath, "CodecList", sCodecList);

	CStoreRegistry::SetBOOL(sKeyPath, "Blocked", bBlocked);

	return TRUE;
}

BOOL CStoreUser::GetUser(LPCTSTR sUserName, CString& sPassword, CString& sCodecList, BOOL& bBlocked)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s", ROOT_PATH, sUserName);

	CStoreRegistry::SetTEXT(sKeyPath, "UserName", sUserName);
	CStoreRegistry::GetTEXT(sKeyPath, "Password", sPassword);
	CStoreRegistry::GetTEXT(sKeyPath, "CodecList", sCodecList);

	CStoreRegistry::GetBOOL(sKeyPath, "Blocked", bBlocked);
	return TRUE;
}

void CStoreUser::GetUserAll(CStringList* pLoginList)
{
	pLoginList->RemoveAll();

	CString sKeyPath;
	sKeyPath =  ROOT_PATH;

	CStoreRegistry::EnumSubKeys(sKeyPath, pLoginList);
}

BOOL CStoreUser::RemoveUser(LPCTSTR sUserName )
{
	CString sKeyPath;
	sKeyPath.Format("%s%s", ROOT_PATH, sUserName);

	CStoreRegistry::DeleteSubKey(sKeyPath);
    return TRUE;
}

BOOL CStoreUser::AddUserRoute(LPCTSTR sUserName, LPCTSTR sUserPrefix, LPCTSTR sDialPrefix, int nToPeerType, LPCTSTR sToPeerName)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s", ROOT_PATH, sUserName);

	CStoreRegistry::SetTEXT(sKeyPath, "UserPrefix", sUserPrefix);
	CStoreRegistry::SetTEXT(sKeyPath, "DialPrefix ", sDialPrefix);
	CStoreRegistry::SetTEXT(sKeyPath, "ToPeerName", sToPeerName);

	CStoreRegistry::SetINT(sKeyPath, "ToPeerType", nToPeerType);
	return TRUE;
}

BOOL CStoreUser::GetUserRoute(LPCTSTR sUserName, CString& sUserPrefix, CString& sDialPrefix, int& nToPeerType, CString& sToPeerName)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s", ROOT_PATH, sUserName);

	CStoreRegistry::GetTEXT(sKeyPath, "UserPrefix", sUserPrefix);
	CStoreRegistry::GetTEXT(sKeyPath, "DialPrefix ",  sDialPrefix);
	CStoreRegistry::GetTEXT(sKeyPath, "ToPeerName", sToPeerName);

	CStoreRegistry::GetINT(sKeyPath, "ToPeerType", nToPeerType);
	return TRUE;
}

BOOL CStoreUser::RemoveUserRoute(LPCTSTR sUserName)
{
	CString sKeyPath;
	sKeyPath.Format("%s%s", ROOT_PATH, sUserName);

	CStoreRegistry::DeleteValue(sKeyPath, "UserPrefix");
	CStoreRegistry::DeleteValue(sKeyPath, "DialPrefix");
	CStoreRegistry::DeleteValue(sKeyPath, "ToPeerName");
	CStoreRegistry::DeleteValue(sKeyPath, "ToPeerType");

	return TRUE;
}

BOOL CStoreUser::IsDataStored()
{
    return CStoreRegistry::IsKeyExist(ROOT_PATH);

}
