#pragma once

#include "VaxServerExCOM.h"

class CStatusLogDlg;
class CErrorLogDlg;
class CVaxSettingDefault;

class CVaxServerSIP : public CVaxServerExCOM
{

public:

	CStatusLogDlg* m_pStatusLogDlg;
	CErrorLogDlg* m_pErrorLogDlg;

public:

	CVaxServerSIP();
	~CVaxServerSIP();
	
private:

	CVaxSettingDefault* m_pVaxSettingDefault;

public:

	BOOL Initialize(LPCTSTR sDomainRealm, LPCTSTR sSIPListenIP, int nSIPListenPort);
	BOOL GetInitialize(CString& sSIPListenIP,  int& nSIPListenPort);

	BOOL LoadMusicHold(LPCTSTR sFileName);
	CString GetMusicHold();

	BOOL LoadMusicDialTone(LPCTSTR sFileName);
	CString GetDialToneMusic();
	
public:

	BOOL AddUser(LPCTSTR sLogin, LPCTSTR sPassword, LPCTSTR sCodecList, BOOL bBlocked, LPCTSTR sUserPrefix, LPCTSTR sDialPrefix, int nToPeerType, LPCTSTR sToPeerName);
	void RemoveUser(LPCTSTR sLogin);

	BOOL GetUserDetails(LPCTSTR sUserName, CString& sPassword, CString& sCodecList, BOOL& bBlocked, CString& sUserPrefix, CString& sDialPrefix,  int& nToPeerType, CString& sToPeerName);
	void GetUserAll(CStringList* pUserList);
    
	BOOL AddLine(LPCTSTR sLineName, LPCTSTR sDisplayName, LPCTSTR sUserName, LPCTSTR sAuthUser, LPCTSTR sAuthPwd, LPCTSTR sDomainRealm, LPCTSTR sProxySIP, LPCTSTR sCodecList, BOOL bRegister, int nToPeerType, LPCTSTR sToPeerName, BOOL bRejected, LPCTSTR sRoomName);
	void RemoveLine(LPCTSTR sLineName);

	BOOL GetLineDetails(LPCTSTR sLineName, CString& sDisplayName, CString& sUserName, CString& sAuthUser, CString&sAuthPwd, CString& sDomainRealm, CString& sProxySIP, CString& sCodecList, BOOL& bRegister, int& nToPeerType, CString& sToPeerName, BOOL& bRejected, CString& sRoomName);
	void GetLineAll(CStringList* pLineList);
			
	BOOL AddDirectProxySIP(LPCTSTR sProxyName, LPCTSTR sAuthLogin, LPCTSTR sAuthPwd, LPCTSTR sDomainRealm, LPCTSTR sProxyIP, LONG lProxyPort, LPCTSTR sCodecList, int nToPeerType, LPCTSTR sToPeerName, BOOL bRejected, LPCTSTR sRoomName);
	void RemoveDirectProxySIP(LPCTSTR sProxyName);

	BOOL GetDirectProxyAll(CStringList* pDirectProxyList);
	BOOL GetDirectProxyDetails(LPCTSTR sProxyName, CString& sAuthLogin, CString& sAuthPwd, CString& sDomainRealm, CString& sProxyIP, LONG& lProxyPort, CString& sCodecList, int& nToPeerType, CString& sToPeerName, BOOL& bRejected, CString& sRoomName);
	
	BOOL AddRoom(LPCTSTR sRoomName, LPCTSTR sRoomNo);
	void RemoveRoom(LPCTSTR sRoomName);

	BOOL GetRoomDetails(LPCTSTR sRoomName, CString& sRoomNo);
	BOOL GetRoomAll(CStringList* pRoomList);
	
private:

	void LoadUser();

	void LoadLine();
	void LoadDirectProxy();
	void LoadRoom();

public:

	void OnInitialize();
	void OnStatusLog(LPCTSTR sMsg);
	void OnErrorLog(LPCTSTR sMsg);

};

