#include "stdafx.h"
#include "VaxServerSIP.h"
#include "StoreRegistry.h"
#include "StoreCOMM.h"
#include "StoreUser.h"
#include "StoreLine.h"
#include "StoreDirectProxy.h"
#include "StoreRoom.h"
#include "VaxSettingDefault.h"


CVaxSettingDefault::CVaxSettingDefault(CVaxServerSIP* pServerSIP)
{
	m_pServerSIP = pServerSIP;
}

CVaxSettingDefault::~CVaxSettingDefault(void)
{
}

BOOL CVaxSettingDefault::LoadUserDefault()
{
	CStoreUser objStoreUser;

	if(objStoreUser.IsDataStored())
		return FALSE;
	
	for(int nCount = 4040; nCount < 4050; nCount++)
	{
		CString sLogin;
		sLogin.Format("%d", nCount);

		m_pServerSIP->AddUser(sLogin, sLogin, "32014", FALSE, "", "", -1, "");
	}

	return TRUE;
}

BOOL CVaxSettingDefault::LoadLineDefault()
{
	CStoreLine objStoreLine;

	if(objStoreLine.IsDataStored())
		return FALSE;
	
	m_pServerSIP->AddLine("Line", "9090", "9090", "9090", "9090", "192.168.0.119", "192.168.0.119", "01234", FALSE, -1, "", FALSE, "");
	return TRUE;
}

BOOL CVaxSettingDefault::LoadRoomDefault()
{
	CStoreRoom objStoreRoom;

	if(objStoreRoom.IsDataStored())
		return FALSE;
	
	m_pServerSIP->AddRoom("Room-TechTalk", "8888");
	return TRUE;
}